package betterwithmods.module.hardcore.crafting;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMRecipes;
import betterwithmods.common.blocks.BlockFurnace;
import betterwithmods.module.Feature;
import com.google.common.collect.Maps;
import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.Ingredient;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

import java.util.HashMap;

public class HCFurnace extends Feature {
    public HCFurnace() {
        enabledByDefault = false;
    }

    public static int DEFAULT_FURNACE_TIMING = 200;
    public static HashMap<Ingredient, Integer> FURNACE_TIMINGS = Maps.newHashMap();

    public static final Block FURNACE = new BlockFurnace(false).setRegistryName("minecraft:furnace");
    public static final Block LIT_FURNACE = new BlockFurnace(true).setRegistryName("minecraft:lit_furnace");

    @Override
    public void setupConfig()
    {
        DEFAULT_FURNACE_TIMING = loadPropInt("Default Furnace Timing", "Default number of ticks for an item to smelt in the furnace (vanilla is 200)", "", 200, 1, Integer.MAX_VALUE);
    }

    @Override
    public void preInit(FMLPreInitializationEvent event) {
        BWMBlocks.registerBlock(FURNACE);
        BWMBlocks.registerBlock(LIT_FURNACE, null);
    }


    @Override
    public void init(FMLInitializationEvent event) {


        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150482_ag));
        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150365_q));
        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150412_bA));
        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150450_ax));
        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150369_x));
        BWMRecipes.removeFurnaceRecipe(new ItemStack(Blocks.field_150371_ca));

        //Remove Furnace Recyclcing

        BWMRecipes.removeFurnaceRecipe(Items.field_151020_U);
        BWMRecipes.removeFurnaceRecipe(Items.field_151023_V);
        BWMRecipes.removeFurnaceRecipe(Items.field_151022_W);
        BWMRecipes.removeFurnaceRecipe(Items.field_151029_X);
        BWMRecipes.removeFurnaceRecipe(Items.field_151035_b);
        BWMRecipes.removeFurnaceRecipe(Items.field_151037_a);
        BWMRecipes.removeFurnaceRecipe(Items.field_151036_c);
        BWMRecipes.removeFurnaceRecipe(Items.field_151019_K);
        BWMRecipes.removeFurnaceRecipe(Items.field_151040_l);
        BWMRecipes.removeFurnaceRecipe(Items.field_151028_Y);
        BWMRecipes.removeFurnaceRecipe(Items.field_151030_Z);
        BWMRecipes.removeFurnaceRecipe(Items.field_151165_aa);
        BWMRecipes.removeFurnaceRecipe(Items.field_151167_ab);
        BWMRecipes.removeFurnaceRecipe(Items.field_151138_bX);
        BWMRecipes.removeFurnaceRecipe(Items.field_151005_D);
        BWMRecipes.removeFurnaceRecipe(Items.field_151011_C);
        BWMRecipes.removeFurnaceRecipe(Items.field_151006_E);
        BWMRecipes.removeFurnaceRecipe(Items.field_151013_M);
        BWMRecipes.removeFurnaceRecipe(Items.field_151010_B);
        BWMRecipes.removeFurnaceRecipe(Items.field_151169_ag);
        BWMRecipes.removeFurnaceRecipe(Items.field_151171_ah);
        BWMRecipes.removeFurnaceRecipe(Items.field_151149_ai);
        BWMRecipes.removeFurnaceRecipe(Items.field_151151_aj);
        BWMRecipes.removeFurnaceRecipe(Items.field_151136_bY);

    }

    @Override
    public void postInit(FMLPostInitializationEvent event) {
        FURNACE_TIMINGS = loadItemStackIntMap("Furnace Timing Recipes", "example recipes  minecraft:iron_ore=1000  or ore:oreIron=1000", new String[]{
                "ore:oreIron=400",
                "ore:oreGold=400",
                "ore:cobblestone=800"
        });



        System.out.println(FURNACE_TIMINGS);
    }
}

